use std::fmt::{self, Display};

// lr0 items described in dragon book page 221

#[derive(Debug, Clone, Hash, Eq, PartialEq)]
pub struct Lr0Item {
    pub lhs: String,
    pub rhs: Vec<String>,
    pub dot: usize,
}

impl Lr0Item {
    pub fn next_symbol(&self) -> &str {
        self.rhs[self.dot].as_ref()
    }
}

impl Display for Lr0Item {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "{} ->", self.lhs)?;
        for (i, sym) in self.rhs.iter().enumerate() {
            if i == self.dot {
                write!(f, " .")?;
            }
            write!(f, " {}", sym)?;
        }
        Ok(())
    }
}
