#[macro_use]
extern crate maplit;
#[macro_use]
extern crate thiserror;

#[macro_use]
mod macros;

mod canonical_collection;
mod grammar;
mod lr;
mod lr0item;
mod utils;

use std::fs::File;
use std::io::Read;

use anyhow::Result;

fn main() -> Result<()> {
    let mut file = File::open("test.bnf")?;
    let mut contents = String::new();
    file.read_to_string(&mut contents)?;

    let mut grammar = make_grammar! {
        E_ -> E,
        E -> E p T | T,
        T -> T a F | F,
        F -> lp E rp | num,
        %
        p -> r"\+",
        a -> r"\*",
        lp -> r"\(",
        rp -> r"\)",
        num -> r"[0-9]+",
    };
    grammar.build();

    println!("Hello, world!");
    Ok(())
}
